#!/usr/bin/env ruby
require "fileutils"

rails_root = nil
make_symlink = true

if ARGV.length > 0
  ARGV.each{|arg|
    if /^(-h|--help|-p|--pretend|-t|--backtarce)$/ =~ arg
      make_symlink = false
    elsif /^-/ !~ arg
      rails_root = arg
    end
  }
end

load('/usr/share/rails/railties/bin/rails')

rails = "/usr/share/rails"
vendor_dir = File.expand_path("vendor", rails_root)

if make_symlink && File.directory?(vendor_dir)
  unless File.exist?(File.expand_path("rails", vendor_dir))
    begin
      FileUtils.ln_s(rails, vendor_dir)
    rescue => ex
      $stderr.puts ex.message
    end
  end
end
