%global momorel 3
%global md5sum_src0 ec4cfe19aad379b03891d7809ab02fc8

Name: rails
Version: 1.2.2
Release: %{momorel}m%{?dist}
Summary: Web-application framework with template engine, control-flow layer, and ORM.
License: MIT/X
Group: Development/Libraries
%NoSource 0 http://rubyforge.org/frs/download.php/17236/rails-%{version}.tgz %{md5sum_src0}
Source1: rails.rb
Patch0: rails-vendor-path.patch
URL: http://www.rubyonrails.org/
BuildRequires: coreutils
BuildRequires: tar
BuildRequires: sed
BuildRequires: ruby-devel >= 1.8.6-3m
Requires: rake >= 0.7.1
Requires: ruby >= 1.8.6-3m
Requires: ruby-activesupport = 1.4.1
Requires: ruby-activerecord = 1.15.2
Requires: ruby-actionpack = 1.13.2
Requires: ruby-actionmailer = 1.3.2
Requires: ruby-actionwebservice = 1.2.2
Requires: util-linux
Requires: ruby-doc
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
%global RI_DIR /usr/share/ri/1.8/system/

%description
Rails is a framework for building web-application using CGI, FCGI,
mod_ruby, or WEBrick on top of either MySQL, PostgreSQL, SQLite, DB2,
SQL Server, or Oracle with eRuby- or Builder-based templates.

%package -n ruby-activesupport
Version: 1.4.1
Summary: Support and utility classes used by the Rails framework.
Group: Development/Libraries
Requires: ruby >= 1.8.2
%description -n ruby-activesupport
Utility library which carries commonly used classes and goodies
from the Rails framework

%package -n ruby-activerecord
Version: 1.15.2
Summary: Implements the ActiveRecord pattern for ORM.
Group: Development/Libraries
Requires: ruby >= 1.8.2
Requires: ruby-activesupport = 1.4.1
%description -n ruby-activerecord
Implements the ActiveRecord pattern (Fowler, PoEAA) for ORM. It
ties database tables and classes together for business objects,
like Customer or Subscription, that can find, save, and destroy
themselves without resorting to manual SQL.

%package -n ruby-actionpack
Version: 1.13.2
Summary: Web-flow and rendering framework putting the VC in MVC.
Group: Development/Libraries
Requires: ruby >= 1.8.2
Requires: ruby-activesupport = 1.4.1
%description -n ruby-actionpack
Eases web-request routing, handling, and response as a half-way
front, half-way page controller. Implemented with specific emphasis
on enabling easy unit/integration testing that doesn't require a browser.
#'

%package -n ruby-actionmailer
Version: 1.3.2
Summary:  Service layer for easy email delivery and testing.
Group: Development/Libraries
Requires: ruby >= 1.8.2
Requires: ruby-actionpack = 1.13.2
%description -n ruby-actionmailer
Makes it trivial to test and deliver emails sent from a single service layer.

%package -n ruby-actionwebservice
Version: 1.2.2
Summary: Web service support for Action Pack.
Group: Development/Libraries
Requires: ruby >= 1.8.4
Requires: ruby-actionpack = 1.13.2
Requires: ruby-activerecord = 1.15.2
%description -n ruby-actionwebservice
Adds WSDL/SOAP and XML-RPC web service support to Action Pack

%global ruby_libdir %(ruby -rrbconfig -e 'puts Config::CONFIG["rubylibdir"]')
%global railsdir %{_datadir}/%{name}

%prep
%setup -q -n %{name}
%patch0 -p1

%install
%__rm -rf %{buildroot}

%__mkdir_p %{buildroot}%{_bindir}

# normalize sh-bang line of executable scripts
for cmd in vendor/rails/railties/dispatches/*.*; do
	%__sed '1s,^#!/usr/local/bin/ruby,#!/usr/bin/env ruby,' $cmd > $cmd.tmp
	%__mv -f $cmd.tmp $cmd
done

# fix permissions
find . -type d -exec %__chmod 755 '{}' \;
find . -type f -exec %__chmod 644 '{}' \;

%__mkdir_p %{buildroot}%{_datadir}/%{name}
%__mkdir_p %{buildroot}%{ruby_libdir}
for dir in vendor/rails/railties vendor/rails/ac*; do
        base=`basename $dir`
        docdir=`pwd`/doc.$base
        %__mkdir_p %{buildroot}/%{_datadir}/%{name}/$base
        %__mkdir_p $docdir
        pushd $dir
        (%__tar -cf - .) | (cd %{buildroot}/%{_datadir}/%{name}/$base; %__tar xf -)
        %__mv CHANGELOG README $docdir
        [ -f MIT-LICENSE ] && %__mv MIT-LICENSE $docdir
        [ -f TODO ] && %__mv TODO $docdir
        [ -d examples ] && %__mv examples $docdir
        popd
done

%__mkdir_p %{buildroot}%{RI_DIR}
for dir in vendor/rails/ac*; do
        pushd $dir
        # create ri docs
        echo "create ri document in " `pwd`
        rdoc --ri  --all --op ri lib
        find . -name created.rid | xargs rm
        cp -a ri/* %{buildroot}/%{RI_DIR}
        popd
done

rm %{buildroot}/%{RI_DIR}/Array/cdesc-Array.yaml                \
   %{buildroot}/%{RI_DIR}/Binding/cdesc-Binding.yaml            \
   %{buildroot}/%{RI_DIR}/CGI/cdesc-CGI.yaml                    \
   %{buildroot}/%{RI_DIR}/Class/cdesc-Class.yaml                \
   %{buildroot}/%{RI_DIR}/Continuation/cdesc-Continuation.yaml  \
   %{buildroot}/%{RI_DIR}/DRb/DRbObject/cdesc-DRbObject.yaml    \
   %{buildroot}/%{RI_DIR}/DRb/cdesc-DRb.yaml                    \
   %{buildroot}/%{RI_DIR}/Date/cdesc-Date.yaml                  \
   %{buildroot}/%{RI_DIR}/Enumerable/cdesc-Enumerable.yaml      \
   %{buildroot}/%{RI_DIR}/Exception/cdesc-Exception.yaml        \
   %{buildroot}/%{RI_DIR}/FalseClass/cdesc-FalseClass.yaml      \
   %{buildroot}/%{RI_DIR}/Fixnum/cdesc-Fixnum.yaml              \
   %{buildroot}/%{RI_DIR}/Hash/cdesc-Hash.yaml                  \
   %{buildroot}/%{RI_DIR}/IRB/Context/cdesc-Context.yaml        \
   %{buildroot}/%{RI_DIR}/IRB/InputCompletor/cdesc-InputCompletor.yaml \
   %{buildroot}/%{RI_DIR}/IRB/WorkSpace/cdesc-WorkSpace.yaml    \
   %{buildroot}/%{RI_DIR}/IRB/cdesc-IRB.yaml                    \
   %{buildroot}/%{RI_DIR}/Integer/cdesc-Integer.yaml            \
   %{buildroot}/%{RI_DIR}/Kernel/cdesc-Kernel.yaml              \
   %{buildroot}/%{RI_DIR}/Logger/cdesc-Logger.yaml              \
   %{buildroot}/%{RI_DIR}/Module/cdesc-Module.yaml              \
   %{buildroot}/%{RI_DIR}/NameError/cdesc-NameError.yaml        \
   %{buildroot}/%{RI_DIR}/NilClass/cdesc-NilClass.yaml          \
   %{buildroot}/%{RI_DIR}/Numeric/cdesc-Numeric.yaml            \
   %{buildroot}/%{RI_DIR}/Object/cdesc-Object.yaml              \
   %{buildroot}/%{RI_DIR}/Pathname/cdesc-Pathname.yaml          \
   %{buildroot}/%{RI_DIR}/Proc/cdesc-Proc.yaml                  \
   %{buildroot}/%{RI_DIR}/Range/cdesc-Range.yaml                \
   %{buildroot}/%{RI_DIR}/Regexp/cdesc-Regexp.yaml              \
   %{buildroot}/%{RI_DIR}/String/cdesc-String.yaml              \
   %{buildroot}/%{RI_DIR}/Symbol/cdesc-Symbol.yaml              \
   %{buildroot}/%{RI_DIR}/Test/Unit/Error/cdesc-Error.yaml      \
   %{buildroot}/%{RI_DIR}/Test/Unit/TestCase/cdesc-TestCase.yaml \
   %{buildroot}/%{RI_DIR}/Test/Unit/cdesc-Unit.yaml             \
   %{buildroot}/%{RI_DIR}/Test/cdesc-Test.yaml                  \
   %{buildroot}/%{RI_DIR}/Time/cdesc-Time.yaml                  \
   %{buildroot}/%{RI_DIR}/TrueClass/cdesc-TrueClass.yaml        \
   %{buildroot}/%{RI_DIR}/YAML/Omap/cdesc-Omap.yaml             \
   %{buildroot}/%{RI_DIR}/YAML/cdesc-YAML.yaml

%__install -m755 %{SOURCE1} %{buildroot}%{_bindir}/rails

%clean
%__rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc doc/api
%{_bindir}/rails
%{_datadir}/rails/railties/

%files -n ruby-activesupport
%defattr(-,root,root)
%doc doc.activesupport/*
%{_datadir}/rails/activesupport/
%{RI_DIR}/ActiveSupport
#%{RI_DIR}/Array
%{RI_DIR}/BigDecimal
%{RI_DIR}/Binding/of_caller-c.yaml
%{RI_DIR}/Breakpoint
%{RI_DIR}/Builder
#%{RI_DIR}/CGI
#%{RI_DIR}/Class
%{RI_DIR}/ClassInheritableAttributes
#%{RI_DIR}/Continuation
#%{RI_DIR}/DRb
#%{RI_DIR}/Date
%{RI_DIR}/Dependencies
%{RI_DIR}/Enumerable/*
#%{RI_DIR}/Exception
#%{RI_DIR}/FalseClass
#%{RI_DIR}/Hash
%{RI_DIR}/HashWithIndifferentAccess
#%%{RI_DIR}/IRB/*
%{RI_DIR}/Inflector
#%{RI_DIR}/Integer
#%{RI_DIR}/Kernel
#%{RI_DIR}/Logger
%{RI_DIR}/MissingSourceFile
#%{RI_DIR}/Module
#%{RI_DIR}/NilClass
#%{RI_DIR}/Numeric
#%{RI_DIR}/Object
#%{RI_DIR}/OrderedHash
%{RI_DIR}/OrderedOptions
#%{RI_DIR}/Pathname
#%{RI_DIR}/Proc
#%{RI_DIR}/Range
%{RI_DIR}/Reloadable
#%{RI_DIR}/String
%{RI_DIR}/Symbol/to_proc-i.yaml
#%{RI_DIR}/Test/Unit/Assertions/*
#%{RI_DIR}/Time
%{RI_DIR}/TimeZone
#%{RI_DIR}/TrueClass

%files -n ruby-activerecord
%defattr(-,root,root)
%doc doc.activerecord/*
%{_datadir}/rails/activerecord/
%{RI_DIR}/ActiveRecord
%{RI_DIR}/DB2
%{RI_DIR}/FireRuby
%{RI_DIR}/Fixture
%{RI_DIR}/FixtureClassNotFound
%{RI_DIR}/Fixtures
%{RI_DIR}/Mysql
%{RI_DIR}/MysqlCompat
%{RI_DIR}/OCI8
%{RI_DIR}/OCI8AutoRecover
%{RI_DIR}/OracleConnectionFactory
#%{RI_DIR}/Test/Unit/*
%{RI_DIR}/Transaction
#%{RI_DIR}/YAML/*

%files -n ruby-actionpack
%defattr(-,root,root)
%doc doc.actionpack/*
%{_datadir}/rails/actionpack/
%{RI_DIR}/ActionController
%{RI_DIR}/ActionPack
%{RI_DIR}/ActionView
#%{RI_DIR}/CGI
%{RI_DIR}/CGIMethods
%{RI_DIR}/FalseClass/*
%{RI_DIR}/HTML
%{RI_DIR}/NilClass/*
%{RI_DIR}/Object/*
%{RI_DIR}/Mime
#%{RI_DIR}/Test/Unit/*
%{RI_DIR}/TrueClass/*
%{RI_DIR}/XmlNode
%{RI_DIR}/XmlNodeList
%{RI_DIR}/XmlSimple

%files -n ruby-actionmailer
%defattr(-,root,root)
%doc doc.actionmailer/*
%{_datadir}/%{name}/actionmailer/
%{RI_DIR}/ActionMailer
#%{RI_DIR}/Enumerable
%{RI_DIR}/MailHelper
%{RI_DIR}/StringInput
%{RI_DIR}/StringOutput
%{RI_DIR}/TC_Unquoter
%{RI_DIR}/TMail
%{RI_DIR}/TestText__Format
%{RI_DIR}/Text

%files -n ruby-actionwebservice
%defattr(-,root,root)
%doc doc.actionwebservice/*
%{_datadir}/%{name}/actionwebservice/
%{RI_DIR}/ActionWebService
#%{RI_DIR}/Class
#%{RI_DIR}/Test
%{RI_DIR}/XMLRPC

%changelog
* Thu Apr 12 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.2.2-3m)
- add BuildRequires  ruby-devel >= 1.8.6-3m

* Tue Mar 13 2007 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (1.2.2-2m)
- avoid conflicts with ruby-1.8.6

* Thu Feb 08 2007 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (1.2.2-1m)
- version up 1.2.2

* Fri Jan 19 2007 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (1.2.1-1m)
- version up 1.2.1
- remove patch1

* Tue Jan 16 2007 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (1.1.6-5m)
- add patch1 for ruby-1.8.5

* Tue Sep 19 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.1.6-4m)
- move %%{RI_DIR}/Test to ruby-activesupport
-- avoid conflict

* Tue Sep 19 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.1.6-3m)
- remove conflict files (but Test directory is still conflict)
-- prease remove Test from ruby-activerecord or ruby-activesupport
-- add Requires: ruby-doc (for directories)

* Fri Sep  8 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.6-2m)
- modify based on NaCl's spec

* Thu Aug 11 2006 zunda <zunda at freeshell.org>
- (1.1.6-1m)
- new version.

* Wed Aug  9 2006 zunda <zunda at freeshell.org>
- (1.1.5-1m)
- new version.

* Fri Jul 28 2006 zunda <zunda at freeshell.org>
- (1.1.4-2m)
- rails-1.1.4.symlink.patch: added to make a symlink when not frozen for
  Momonga without gems
- usr-bin-rails.rb: renamed from rails.sh, modified accordingly

* Fri Jun 30 2006 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.1.4-1m)
- new version.

* Thu Jun 29 2006 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.1.3-1m)
- new version.

* Fri Dec 14 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.0.0-1m)
- new version.

* Fri Dec 09 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.14.4-1m)
- new version. (This version is a.k.a. RC5)

* Tue Nov 15 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.14.3-1m)
- new version. (This version is a.k.a. RC4)
- split into subpackages and define dependencies among them.

* Thu Sep 22 2005 OZAWA Sakuro <crouton@momonga-linux.org> 
- (0.13.1-4m)
- fix clean logger problem on Ruby 1.8.3.

* Mon Aug  1 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.13.1-3m)
- add a note to config/environment.rb about using Rails' fallback MySQL interface in Momonga.

* Sun Jul 31 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.13.1-2m)
- fix sh-bang normalization (esp. for script/runner).
- fix building requirement.

* Sat Jul 30 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.13.1-1m)
